package SquareServer;

import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Graphics.*;
import comm.*;
import java.util.Vector;
  
public class SquareServer
{
    static boolean attiva_ridistribuzione = false;
    static boolean out = false;
    static UsersList utenti = new UsersList();
    static UsersList utenti_remoti[] = new UsersList[20]; // al massimo 20 server
    static boolean   ur_attivi[] = { false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, };
    static int numero_utenti    = 0;
    static int numero_servitori = 0;
    static Gestori_Clienti_ThreadGroup   gc = new Gestori_Clienti_ThreadGroup("gestori clienti");
    static Gestori_Servitori_ThreadGroup gs = new Gestori_Servitori_ThreadGroup("gestori servitori");

    static myCanvas stat;
    static int port = 0;

    public static void main(String a[]) throws IOException
    {
	int port = 0;
	boolean err = false;

	if(a.length == 0)
	    err = true;

	if (a.length == 1)
	    {
		if (a[0].equals("-v"))
		    {
			err = true;
			System.out.println("SquareServer versione 1.0");
			System.out.println("di Andrea Di Cesare");
			System.out.println("Ridistribuzione del carico v 1.0 di Nicola Vargiu"); 
		    }
		else
		    {
			try
			    {
				port = Integer.parseInt(a[0]); 
				SquareServer.port = port; // ridistribuzione
			    }
			catch(Exception e)
			    {
				err = true;
			    }
		    }
	    }

	if (a.length == 2)
	    {
		if (a[0].equals("-d"))
		    {
			out = true;
			try
			    {
				port = Integer.parseInt(a[1]); 
				SquareServer.port = port;
			    }
			catch(Exception e)
			    {
				err = true;
			    }
		    }
		if (a[0].equals("-v"))
		    {
			System.out.println("Square versione 1.0");
			System.out.println("di Andrea Di Cesare");
			System.out.println("Ridistribuzione del carico v 0.5 di Nicola Vargiu");			
			try
			    {
				port = Integer.parseInt(a[1]); 
				SquareServer.port = port;
			    }
			catch(Exception e)
			    {
				err = true;
			    }
		    }
	    }
				
	if (err)
	    {
		System.err.println("Errore: specificare la porta di connessione");
		System.err.println("Uso: SquareServer [opt] porta");
		System.err.println("opzioni");
		System.err.println("-v          stampa la versione");
		System.err.println("-d          stampa molte informazioni sull'esecuzione di Square");
		System.exit(0);
	    }

	// inizializzazione interfaccia utente (AWT 1.1)

	System.err.println("MainServer: porta locale " + SquareServer.port);

	myFrame ServerFrame = new myFrame("Square Server");
      
	Socket sock;
	ServerSocket servsock = new ServerSocket(port);

	while(true) // loop di accettazione
	    {
		try
		    {            
			sock = servsock.accept();
			if (SquareServer.out) System.err.println("MainServer: Ho ricevuto una richiesta di connessione");
			// a questo punto dobbiamo capire se si  connesso un client o un server

			ObjectInputStream ois  = new ObjectInputStream( sock.getInputStream());
			comando cmd = (comando) ois.readObject(); // APRE LO STREAM DI INPUT

			if (cmd.cmd.equals("CLIENTE"))
			    {
				// si  collegato un cliente
				if (SquareServer.out) System.err.println("MainServer: Ho accertato che la richiesta proviene da un Cliente");
				gestore_cliente c = new gestore_cliente(gc,sock,ois);
				c.start();
				numero_utenti = gc.activeCount();
				SquareServer.stat.repaint();
			    }

			if (cmd.cmd.equals("SERVITORE"))
			    {
				// si  collegato un servitore
				if (SquareServer.out) System.err.println("MainServer: Ho accertato che la richiesta proviene da un Server remoto");

				// assegnamogli un indice nel Vettore di stati utenti_remoti che dovr gestire
				int cont;
				boolean flag = false;
				for(cont = 0; cont < 20; cont++)
				    if (! ur_attivi[cont])
					{
					    flag = true;
					    break; // ovviamente cont  il primo indice corrispondente ad uno "slot libero"
					}

				if (flag == false) // errore non ci sono slot liberi
				    {
					System.err.println("Errore troppi server: al massimo 20");
					sock.close();
				    }
				else
				    {
					int port2 = Integer.parseInt(cmd.arg[1]);
					System.err.println("MainServer: creo il gestore_server passandogli");
					System.err.println("MainServer: porta locale : " + SquareServer.port);
					System.err.println("MainServer: porta remota :" + port2);
					gestore_servitore s = new gestore_servitore(gs ,sock ,cont, false, ois, null, SquareServer.port, port2);
					// il valore false determina il comportamento passivo del thread
					// in questo caso, server passivo, port deve contenere il numero di port del server che ha richiesto la connessione (remoto)
					s.start();
					numero_servitori = gs.activeCount();
					SquareServer.stat.repaint();
				    }
			    }
		    }
		catch(Exception ex)
		    {
			System.out.println("MainServer : Errore " + ex);
		    }
	    }
    }
}

class myFrame extends Frame
{

    myFrame(String s)
    {
	super(s);

	this.setSize(400,300);
	this.addWindowListener(new myWindowListener());

	SquareServer.stat = new myCanvas();
	SquareServer.stat.setSize(400,100);
	myTextField i = new myTextField("",20);
	myTextField p = new myTextField("",20);
	myButton b = new myButton("Aggiungi il server", i,p);

	this.add("North",SquareServer.stat);
	this.add("West",i);
	this.add("Center",p);
	this.add("East",b);

	this.setVisible(true);
    }
}

class myButton extends Button
{
    myButton(String s, TextField i, TextField p)
    {
	super(s);
	this.addActionListener(new myActionListener(i, p));
	this.setActionCommand("COLLEGA");
    }
}

class myTextField extends TextField
{
    myTextField(String s,int c)
    {
	super(s,c);
    }
}

class myCanvas extends Canvas
{
    myCanvas()
    {
	super();
    }

    public void paint(Graphics g)
    {
	g.drawString("utenti: " + SquareServer.numero_utenti, 10,30);
	g.drawString("server attivi: " + SquareServer.numero_servitori, 10,50);
    }
} 

class myActionListener implements ActionListener
{
    TextField i;
    TextField p;

    myActionListener(TextField i, TextField p)
    {
	this.i = i;
	this.p = p;
    }
 
    public void actionPerformed(ActionEvent e)
    { 
	try
	    {
		int         port = Integer.parseInt(p.getText()); 
		InetAddress iadd = InetAddress.getByName(i.getText());
		
		// tenta di creare la socket di collegamento
		Socket sock = new Socket(iadd, port );

		// se tutto  andato bene lanciamo un gestore_server specificandogli il gruppo_gestori_server gs,
		// la socket, e lo slot libero e che deve avere un comportamento attivo 
		// il valore true determina il comportamento attivo del thread; cio esso comunica al pari che 
		// si deve iniziare un coordinamento


		// nota: gli stream vengono creati in ordine inverso rispetto al caso passivo
		ObjectOutputStream oos  = new ObjectOutputStream( sock.getOutputStream());
		oos.flush();

		// cerco un indice nell'array utenti_remoti libero
		boolean FLAG = false;
		int cont;
		for (cont = 0; cont < 20; cont++)
		    if (! SquareServer.ur_attivi[cont])
			{
			    FLAG = true;
			    break;
			}

		if (FLAG)
		    {
			gestore_servitore s = new gestore_servitore(SquareServer.gs,sock,cont ,true, null, oos, SquareServer.port, port);	
			s.start();
			SquareServer.numero_servitori = SquareServer.gs.activeCount();
			SquareServer.stat.repaint();
		
			if (SquareServer.out) System.err.println("MainServer: link al server " + i.getText() + " sulla porta " + p.getText() + " effettuato");

			// rimuovi vecchi valori nei TextField
			i.setText("");
			p.setText("");
		    }
		else
		    {
			sock.close();
			System.err.println("Errore: troppi server; al massimo 20");
		    }
	    }
	catch(UnknownHostException uhe)
	    {
		// l'indirizzo non  valido
		System.err.println("MainServer: l'indirizzo specificato non e' valido");
	    }
	catch(NumberFormatException nfe)
	    {
		// la porta non  valida
		System.err.println("MainServer: la porta specificata non e' valida");
	    }
	catch(Exception e2)
	    {
		// altro errore
		System.err.println("MainServer: errore nel tentare il collegamento al server " + e2);
	    }
    }
}

class myWindowListener implements WindowListener
{
    myWindowListener()
    {

    }
    
    public void windowClosing(WindowEvent e)
    {
	// si dovrebbe chiedere conferma <--------------------
	System.exit(0);
    }
    //   Invoked when a window is in the process of being closed. 

    public void windowClosed(WindowEvent e) {}
    //  Invoked when a window has been closed. 
    public void windowActivated(WindowEvent e) {}
    //     Invoked when a window is activated. 
    public void windowDeactivated(WindowEvent e) {} 
    //  Invoked when a window is de-activated. 
    public void windowDeiconified(WindowEvent e) {}
    // Invoked when a window is de-iconified. 
    public void windowIconified(WindowEvent e) {}
    // Invoked when a window is iconified. 
    public void windowOpened(WindowEvent e) {}
    // Invoked when a window has been opened. 
}
