package SquareServer;

import java.io.*;
import java.net.*;
import comm.*;

public class gestore_cliente extends Thread
{
  Socket sock;
  String nome = "Sconosciuto!";
  ObjectOutputStream oos;
  ObjectInputStream  ois;
  boolean morente = false;
    boolean risultato_login = true; // utilizzato per il controllo del nome
    int     server_da_controllare = 0;// utilizzato per il controllo del nome

  public gestore_cliente(ThreadGroup tg, Socket sock,ObjectInputStream ois)
    {
      super(tg, sock.toString());
      this.sock = sock;
      this.ois = ois;
    }

  public void run()
    {
      int cont;
      comando c;

      try
	{
	  for(;;) // loop di gestione
	    {
	      boolean FLAG_CLIENT = false;
	      boolean FLAG_SERVER = false;
	      c = (comando) ois.readObject(); // RICEZIONE COMANDO
		  		     
	      if (SquareServer.out) System.err.println("gestore client: ho ricevuto dal client: " + nome + " il comando: " + c.cmd);

	      // **********************************************************
	      // NUOVO UTENTE
	      if (c.cmd.equals("NUOVO"))
		{
		  int flag = 0;
		  boolean s;
		  oos = new ObjectOutputStream ( sock.getOutputStream() );
		  oos.flush();

		  if(c.arg[4].equals("UOMO"))
		    s = true;
		  else
		    s = false;

		  user nuovo = new user(c.arg[0],s);
		  this.nome = c.arg[0];

		  nuovo.setta_x( Integer.parseInt( c.arg[2] )); //posizione
		  nuovo.setta_y( Integer.parseInt( c.arg[3] ));

		  nuovo.setta_espressione( Integer.parseInt(c.arg[1]) );

		  String risposta = "";
		
		  // nuovo utente, controlla se il suo nickname e' gia' in uso nel server locale
		  if (SquareServer.utenti.indice(nome) != -1)
		    {
		      risposta = "nickname in use";
		      flag = 1;
		    }

		  // nuovo utente, controlla se il suo nickname e' gia' in uso nei server remoti
		  if (SquareServer.numero_servitori > 0)
		      {
			  System.err.println("gestore_cliente: inizio verifica del nome " + nome);
			  SquareServer.gs.controlla_nome(nome, this);
			  // mi devo mettere in attesa
			  // all'uscita dall'attesa devo controllare la variabile booleana SquareServer.nome_corretto e andare avanti
			  this.suspend();
			  if ( ! this.risultato_login )
			      {
				  risposta = "nickname in use in a remote server";
				  flag = 1;
			      }
		      }

		  // ---------------- RIDISTRIBUZIONE DEL CARICO

		  if ( SquareServer.numero_servitori > 0)
		      {
			  // calcola chi ha il numero minimo di servitori
			  int min,num;
			  num = -1;
			  min = SquareServer.utenti.size();
			 
			  for(int i = 0; i < 20; i++)
			      {
				  if (SquareServer.ur_attivi[i])
				      {
					  int temp_min = SquareServer.utenti_remoti[i].size();

					  if (temp_min < min)
					      {
						  min = temp_min;
						  num = i;
					      }
				      }
			      }

			  if (num != -1)
			      {
				  // cerco il gestore servitore corrispondente
				  Thread list[] = new Thread[20];
  
				  int n = SquareServer.gs.enumerate(list); 
				  int cont2 = 0;
				  for (cont2 = 0; cont2 < n; cont2++)
				      {
					  if ( ((gestore_servitore) list[cont2]).getName().equals( new String(""+num)));
					  break;
				      }

				  gestore_servitore g = (gestore_servitore) list[num];

				  InetAddress cambia_server_ip   = g.sock.getInetAddress();
				  int         cambia_server_port = g.porta_remota;

				  if (SquareServer.out)
				      {
					  System.err.println("La richiesa di login e' stata ridiretta sul server:");
					  System.err.println("---> porta: " + cambia_server_port);
					  System.err.println("---> ip   : " + cambia_server_ip.toString());
				      }

				  comando risp = new comando("CAMBIA SERVER", cambia_server_ip, cambia_server_port );
				  oos.writeObject( (comando) risp);
				  oos.flush();
				  sock.close();
				  this.stop();
			      }
		      }

		  if (flag != 1)
		    {
		      FLAG_CLIENT = true;
		      FLAG_SERVER = true;
		      risposta = "OK";
		      SquareServer.utenti.addElement(nuovo);
		      if (SquareServer.out) System.err.println("New user : " + nome);
		    }

		  String arg[] = {};
		  comando risp = new comando (risposta, arg);
		  oos.reset();
		  oos.writeObject( (comando) risp);
		  oos.flush();
		}

	      // **********************************************************
	      // UTENTE ESCE
	      if (c.cmd.equals("ESCI"))
		{
		  try
		    {
		      // aggiorna lo stato del server

		      SquareServer.utenti.prendi_controllo();
		      int index = SquareServer.utenti.indice(nome);
		      SquareServer.utenti.removeElementAt(index);
		      SquareServer.utenti.cedi_controllo();

		      ois.close();
		      oos.close();

		      //aggiorna i server remoti
		      SquareServer.gs.aggiorna();

		      // aggiorna lo stato dei client
		      morente = true; // necessario per non aggiornare il client che esce
		      ( (Gestori_Clienti_ThreadGroup) this.getThreadGroup()).aggiorna(); // lo stato  cambiato

		      SquareServer.numero_utenti = SquareServer.gc.activeCount()-1;
		      SquareServer.stat.repaint();
		      sock.close();
		      this.stop();
		    }
		  catch(Exception ex)
		    {
			if (SquareServer.out) System.err.println("gestore client: errore " + ex +" nella fase di log out del client: " + nome);
		    }
		}
	      // **********************************************************
	      // L'UTENTE CAMBIA ESPRESSIONE
	      if (c.cmd.equals("ESPRESSIONE"))
		  {
		      FLAG_CLIENT = true;
		      FLAG_SERVER = true;
		      if (c.arg[0].equals("FELICE"))
			  {
			      user u = (user) SquareServer.utenti.elementAt(SquareServer.utenti.indice(nome));
			      if (u.dammi_espressione() == 0) u.setta_espressione( 1 ); // normale --> felice
			      if (u.dammi_espressione() == 2) u.setta_espressione( 0 ); // arrabiato --> normale
			  }
		      else
			  {
			      user u = (user) SquareServer.utenti.elementAt(SquareServer.utenti.indice(nome));
			      if (u.dammi_espressione() == 0) u.setta_espressione( 2 ); // normale --> arrabiato
			      if (u.dammi_espressione() == 1) u.setta_espressione( 0 ); // felice --> normale
			  }
		  }
	      // **********************************************************
	      // L'UTENTE SI MUOVE
	      if (c.cmd.equals("MUOVI"))
		  {
		      FLAG_CLIENT = true;
		      FLAG_SERVER = true;
		      user u = (user) SquareServer.utenti.elementAt(SquareServer.utenti.indice(nome));
		      u.setta_x( Integer.parseInt(c.arg[0]) );
		      u.setta_y( Integer.parseInt(c.arg[1]) );

		      if (SquareServer.out)
			  System.err.println("gestore client: la nuova posizione di " + nome + " e': " + c.arg[0] + "," + c.arg[1]);
		  }

	      // **********************************************************
	      // L'UTENTE HA INVIATO UN MSG
	      if (c.cmd.equals("MESSAGGIO"))
		  {
		      FLAG_CLIENT = true;
		      int n;
		      String msg = c.arg[0];
		      user temp;
		      user corrente = (user) SquareServer.utenti.elementAt(SquareServer.utenti.indice(this.nome));
		      if (SquareServer.out)
			  System.err.println("gestore client: l'utente " + nome + " ha inviato un msg : " + msg);

		      for (n = 0; n < SquareServer.utenti.size(); n++)
			  {
			      temp = (user) SquareServer.utenti.elementAt(n);
			      if ( ( java.lang.Math.pow( (double) (temp.dammi_x()-corrente.dammi_x()), (double) 2) + java.lang.Math.pow( (double) (temp.dammi_y()-corrente.dammi_y()),(double) 2) ) <= 900 /* R=30 R^2=900 */)
				  {
				      if (SquareServer.out)
					  System.err.println("gestore client: il messaggio " + msg + " e' stato inserito nella lista dei messaggi di " + temp.dammi_nome());

				      temp.add_m(corrente.dammi_nome(), msg);
				      //  necessario inviare il messaggio a tutti i server remoti collegati
				      SquareServer.gs.messaggio( corrente, msg );
				  }
			  }
		  }

	      if (FLAG_CLIENT)
		  // se lo stato  cambiato, aggiorna lo stato dei client
		  SquareServer.gc.aggiorna();
	      if (FLAG_SERVER)  
		  // in pi  necessario aggiornare lo stato degli altri server
		  // in tutti i casi tranne per i messaggi che vengono gestiti diversamente
		  SquareServer.gs.aggiorna();

	    }
	}
      catch(Exception ex)
	{
	  System.err.println("gestore client: Errore " + ex);
	  try
	    {
	      SquareServer.numero_utenti = SquareServer.gc.activeCount()-1;
	      SquareServer.stat.repaint();
	      this.sock.close();
	    }
	  catch(Exception e)
	    {}
	  this.stop();
	}
    }

synchronized public void aggiorna()
    {
      // invia al thread update del cliente il nuovo stato
      if (! morente)
	try
	  {
	    if (SquareServer.out) System.err.println("gestore client: invio al client " + this.nome + " lo stato aggiornato");

	    // lo stato da inviare al client  costituito da una UsersList che ha come elementi tutti gli elementi
	    // della UsersList SquareServer.utenti pi tutti gli elementi delle UsersList che compongono
	    // l'array SquareServer.utenti_remoti[]

	    UsersList stato = new UsersList();

	    // regione critica
	    SquareServer.utenti.prendi_controllo();

	    for (int cont = SquareServer.utenti.size()-1; cont >= 0; cont --)
		stato.addElement(SquareServer.utenti.elementAt(cont));
	    SquareServer.utenti.cedi_controllo();

	    for(int sn = 0; sn < 20; sn++)
		if (SquareServer.ur_attivi[sn])
		    {
			// regione critica
			SquareServer.utenti_remoti[sn].prendi_controllo();
		
			for (int cont = SquareServer.utenti_remoti[sn].size()-1; cont >= 0; cont --)
			    stato.addElement(SquareServer.utenti_remoti[sn].elementAt(cont));
			
			SquareServer.utenti_remoti[sn].cedi_controllo();
		    }

	    // invio lo stato del server 
	    oos.reset();
	    oos.writeObject( (UsersList) stato);
	    oos.flush();
	    // cancello dallo stato del server i messaggi all'utente che sono appena stati recapitati
	    SquareServer.utenti.prendi_controllo();
	    user temp = (user) SquareServer.utenti.elementAt(SquareServer.utenti.indice(nome));
	    temp.rimuovi_messaggi();
	    SquareServer.utenti.cedi_controllo();
	  }
      catch(Exception ex)
	{
	  System.err.println("gestore client: Errore nell'aggiornare lo stato di " + this.nome);
	  System.err.println("gestore client: Errore " + ex);
	  this.stop();
	}
    }

    public boolean equals( Object o)
    {
	if ( (o instanceof gestore_cliente) && ( (gestore_cliente) o).nome == this.nome)
	    return true;
	else
	    return false;
    }


}
