package SquareServer;

import java.io.*;
import java.net.*;
import comm.*;
import java.util.Vector;

public class gestore_servitore extends Thread
{
    int N;  // indice nell'array di stati assegnatoci
    Socket sock;
    String server_remoto;
    ObjectOutputStream oos;
    ObjectInputStream  ois;
    boolean attivo;
    boolean morente = false;
    int porta_locale; // porta di ascolto del server  (utilizzato per la ridistribuzione del carico)
    int porta_remota;
    
    Vector clienti_in_fase_di_login = new Vector(); // utilizzato da controlla_nome

    public gestore_servitore(ThreadGroup tg, Socket sock, int N, boolean attivo,  ObjectInputStream  ois, ObjectOutputStream oos, int porta_locale, int porta_remota)
    // la variabile booleana primo discrimina il comportamento del thread: se  true allora il thread si incarica 
    // di comunicare al pari l'inizio di una collaborazione, altrimenti il suo comportamento  passivo
    {
	super(tg,""+ N);
	this.sock = sock;
	server_remoto = sock.getInetAddress().getHostAddress();
	this.N = N;
	this.ois = ois;
	this.oos = oos;
	this.attivo = attivo;
	SquareServer.ur_attivi[this.N] = true;
	this.porta_locale = porta_locale;
	this.porta_remota = porta_remota;
	System.err.println("gestore servitore: porta locale :" + porta_locale);
	System.err.println("gestore servitore: porta remota : " + porta_remota);
    }

    public void run()
    {
	int cont;
	comando c;

	try
	    {
		if (attivo)
		    {
			// invio messaggio di cooperazione
			
			String arg[] = { "" + this.porta_remota , "" + this.porta_locale };
			comando c2 = new comando("SERVITORE", arg);
			oos.writeObject( (comando) c2);
			oos.flush();

			this.ois   = new ObjectInputStream( sock.getInputStream());
			// invia per la prima volta lo stato
			this.aggiorna();
		    }
		else
		    {
			this.oos   = new ObjectOutputStream( sock.getOutputStream());
			// invia per la prima volta lo stato
			this.aggiorna();
		    }

	    }
	catch(Exception e)
	    {
		System.err.println("gestore servitore: errore nella fase iniziale della collaborazione " + e);
		SquareServer.ur_attivi[this.N] = false;
		this.stop();
	    }

	try
	    {
		for(;;) // loop di gestione
		    {
			boolean FLAG = false;
			
			c = (comando) ois.readObject(); // RICEZIONE COMANDO

			if (SquareServer.out) System.err.println("gestore server: ho ricevuto dal server: " + server_remoto + " il comando " + c.cmd);

			// **********************************************************
			// RISPOSTA AD UNA RICHIESTA DI VERIFICA NOME
			if (c.cmd.equals("RISPOSTA VERIFICA NOME"))
			    {
				System.err.println("gestore_servitore(CLIENT): ho ricevuto la risposta alla richiesta di verificare il nome");

				int indice = Integer.parseInt( c.arg[1] );
				if (c.arg[0].equals("NOME USATO"))
				    {
					System.err.println("gestore_servitore(CLIENT): il nome e' usato");

					( (gestore_cliente) clienti_in_fase_di_login.elementAt(indice)).server_da_controllare--;

					//setta il risultato e riattiva il thread sospeso
					try
					    {
						( (gestore_cliente) clienti_in_fase_di_login.elementAt(indice)).risultato_login = false;
						( (gestore_cliente) clienti_in_fase_di_login.elementAt(indice)).resume();
						clienti_in_fase_di_login.removeElementAt(indice);
					    }
					catch(Exception e)
					    {
						//  possibile che si verifichi un NullPointerException
					    }
				    }
				else
				    {
					System.err.println("gestore_servitore(CLIENT): il nome non e' usato");
					( (gestore_cliente) clienti_in_fase_di_login.elementAt(indice)).server_da_controllare--;
					if ( ( (gestore_cliente) clienti_in_fase_di_login.elementAt(indice)).server_da_controllare == 0)
					    {
						try
						    {
							( (gestore_cliente) clienti_in_fase_di_login.elementAt(indice)).resume();
							clienti_in_fase_di_login.removeElementAt(indice);
						    }
						catch(Exception e)
						    {
							//  possibile che si verifichi un NullPointerException
						    }
					    }
				    }
			    }

			// **********************************************************
			// RICHIESTA DI VERIFICA NOME
			if (c.cmd.equals("VERIFICA NOME"))
			    {
				String nome = c.arg[0];
				int indice = Integer.parseInt( c.arg[1] );
				System.err.println("gestore_servitore(server): ho ricevuto una richiesta di verificare il nome: " + nome + " indice: " + indice);

				if (SquareServer.utenti.indice(nome) != -1)
				    {
					System.err.println("il nome e' usato");
					String arg[] = { "NOME USATO", "" + indice };
					comando c2 = new comando("RISPOSTA VERIFICA NOME",arg);
					try
					    {
						oos.writeObject( (comando) c2);
						oos.flush();
					    }
					catch(Exception e)
					    {
					    }	
				    }
				else
				    {
					System.err.println("il nome non e' usato");
					String arg[] = { "NOME NON USATO", "" + indice };
					comando c2 = new comando("RISPOSTA VERIFICA NOME",arg);
					try
					    {
						oos.writeObject( (comando) c2);
						oos.flush();
					    }
					catch(Exception e)
					    {
					    }
				    }
			    } 


			// **********************************************************
			// IL SERVER HA CAMBIATO LO STATO
			if (c.cmd.equals("STATO"))
			    {
				FLAG = true;

				if (SquareServer.utenti_remoti[N] == null)
				    SquareServer.utenti_remoti[N] = new UsersList();

				// regione critica
				SquareServer.utenti_remoti[N].prendi_controllo();
				SquareServer.utenti_remoti[N] = c.stato;
				SquareServer.utenti_remoti[N].cedi_controllo();
			    }
			// **********************************************************
			// IL SERVER SEGNALA CHE UN CLIENTE HA INVIATO UN MESSAGGIO
			if (c.cmd.equals("MESSAGGIO"))
			    {
				FLAG = true;
				int n;
				String msg = c.arg[1];
				// regione critica
				SquareServer.utenti_remoti[N].prendi_controllo();

				user temp;
				user mittente = (user) SquareServer.utenti_remoti[N].elementAt(SquareServer.utenti_remoti[N].indice(c.arg[0]));
				if (SquareServer.out) System.err.println("gestore server: l'utente " + mittente.dammi_nome() + " ha inviato un msg : " + msg);

				for (n = 0; n < SquareServer.utenti.size(); n++)
				    {
					temp = (user) SquareServer.utenti.elementAt(n);
					if ( ( java.lang.Math.pow( (double) (temp.dammi_x()-mittente.dammi_x()), (double) 2) + java.lang.Math.pow( (double) (temp.dammi_y()-mittente.dammi_y()),(double) 2) ) <= 900 /* R=30 R^2=900 */)
					    {
						if (SquareServer.out) System.err.println("gestore server: il messaggio " + msg + " e' stato inserito nella lista dei messaggi di " + temp.dammi_nome());
						temp.add_m(mittente.dammi_nome(), msg);
					    }
				    }

				SquareServer.utenti_remoti[N].cedi_controllo();
			    }

			if (FLAG)
			    SquareServer.gc.aggiorna(); // se lo stato  cambiato, aggiorna lo stato dei client
		    }
	    }
	catch(Exception ex)
	    {
		System.err.println("Connessione con il server " + this.server_remoto + " chiusa " + ex);
		SquareServer.utenti_remoti[this.N] = null; // libero le risorse associate al server
		SquareServer.numero_servitori = SquareServer.gs.activeCount()-1;
		SquareServer.stat.repaint();
		SquareServer.ur_attivi[this.N] = false;
		this.stop(); // ed uccido il thread
	    }
    }

    synchronized public void aggiorna()
    {
	// invia al thread gestore_server remoto il nuovo stato
	if (! morente)
	    try
		{
		    if (SquareServer.out) System.err.println("gestore_server: invio al server " + this.server_remoto + " lo stato aggiornato");

		    // invio lo stato del server 
		    comando cmd = new comando("STATO", SquareServer.utenti );

		    oos.reset();
		    oos.writeObject( (comando) cmd);
		    oos.flush();
		}
	catch(Exception ex)
	    {
		System.err.println("gestore server: Errore nell'aggiornare lo stato di " + this.server_remoto);
		System.err.println("gestore server: Errore: " + ex);
		SquareServer.ur_attivi[this.N] = false;
		this.stop();
	    }
    }

    public void messaggio(user mittente, String msg)
    {
	try
	    {
		if (SquareServer.out) System.err.println("gestore_server: invio al server " + this.server_remoto + " il messaggio dell'utente " + mittente.dammi_nome());
		String arg[] = { mittente.dammi_nome(), msg };
		comando c = new comando("MESSAGGIO" , arg);

		oos.writeObject( (comando) c);
		oos.flush();
	    }
	catch(Exception ex)
	    {
		System.err.println("gestore servitore: Errore nell'inviare un messaggio");
		SquareServer.ur_attivi[this.N] = false;
		this.stop();
	    }

    }

public void controlla_nome(String nome, gestore_cliente gc)
    {
	//registro il riferimento al gestore_cliente che ha iniziato la fase di controllo del nome
	this.clienti_in_fase_di_login.addElement( (gestore_cliente) gc);
	int indice = clienti_in_fase_di_login.indexOf( (gestore_cliente) gc);

	//invio la richiesta di verificare se c' un utente con il nome "nome"
	System.err.println("gestore_servitore(client): invio la richiesta di verificare il nome: " + nome);
	String arg[] = { nome , "" + indice };
	comando c = new comando("VERIFICA NOME",arg);
	try
	    {
		oos.writeObject( (comando) c);
		oos.flush();
	    }
	catch(Exception e)
	    {
	    }
    }
}
