/* questa class definisce l'oggetto comando, ed  utilizzata per l'interazione client-server 
   si intende infatti gestire la comunicazione c-s sfruttando la possibilita di serializzare oggetti e inviarli su stream */

/* PROTOCOLLO DI INTERAZIONE CLINET-SERVER 

comandi CLIENT

   COMANDO      ARGOMENTI                                                             DESCRIZIONE
----------------------------------------------------------------------------------------------------
   NUOVO        1) nome 2) espressione 3) pos x 4) pos y 5) sesso ("UOMO" o "DONNA")  Apre la sessione
   MUOVI        1) coordinata x 2) coordinata y                                       Muove l'avatar
   ESPRESSIONE  1) l'espressione ("FELICE" o "ARRABBIATO")                            Cambia espressione
   MESSAGGIO    1) il messaggio                                                       Ivia un messaggio
   ESCI                                                                               Chiude la sessione
   AGGIORNA                                                                           Accetta la richiesta di aggiornamento dello stato

comandi SERVER
   COMANDO                             ARGOMENTI                                     DESCRIZIONE
----------------------------------------------------------------------------------------------------
   AGGIORNAMENTO                       1) la UserList                                Richiesta di aggironamento dello stato
   OK                                                                                Accettazione 
   qualsiasi stringa di errore                                                       Segnalazione errore


*/

package comm;

import java.io.*;

public class comando extends java.lang.Object implements Serializable
{
    public String cmd;
    public String arg[];
    public UsersList stato; // utilizzato dai gestore_server
    public java.net.InetAddress ip; // utilizzato per la ridistribuzione del carico
    public int port; // utilizzato per la ridistribuzione del carico

    public comando(String cmd, String arg[])
    {
	this.cmd = cmd;
	this.arg = arg;
    }

    public comando(String cmd)
    {
	this.cmd = cmd;
    }

    public comando(String cmd, UsersList stato)
    {
	this.cmd = cmd;
	this.stato = stato;
    }

    public comando(String cmd, java.net.InetAddress ip, int port)
    {
	this.cmd = cmd;
	this.ip = ip;
	this.port = port;
    }
}
